## Cylinder
mod = Sketchup.active_model
ent = mod.active_entities
ent.clear!
# The global variables below will allow SU to remember your previous settings
$r = 10.mm if not $r
$h = 50.mm if not $h
$n = 24 if not $n
@cyl_orientation = "along Z axis" if not @cyl_orientation 
# Dialog Box construction
cyl_orientation = ["along X axis","along Y axis","along Z axis"]
enums = [cyl_orientation.join("|")]
prompts = ["Orientation", "Radius", "Height", "No. of segments " ]
values = [@cyl_orientation, $r, $h, $n]
results = inputbox prompts, values, enums, "Cylinder Properties"
return if not results
cyl_orientation, $r, $h, $n = results
mod.start_operation "Create Cylinder"
vector = X_AXIS if( results[0] == "along X axis" )
vector=Y_AXIS if( results[0] == "along Y axis" )
vector = Z_AXIS if( results[0] == "along Z axis" )
circle = ent.add_circle(ORIGIN, vector, $r, $n)
base = ent.add_face(circle)
base.pushpull -$h
Sketchup.send_action "viewZoomExtents:"
mod.commit_operation
