## Dome
#draw a circle or square or polygon and select it
mod=Sketchup.active_model()
sel = mod.selection()
ent = mod.entities
@smoothFaces = true
if sel.empty? 
 UI.messagebox("Nothing selected")
else
  mod.start_operation "dome"
  circleInterior = nil
  edgeArray = Array.new()
  sel.each {|e| 
   edgeArray.push(e) if (e.kind_of? Sketchup::Edge)
   circleInterior = e if e.kind_of? Sketchup::Face
  }
  e1 = edgeArray[0]
  p1 = e1.start.position
  p2 = e1.end.position
  
  # get adjacent edge
  vs = e1.end.edges
  if (vs[0] == e1)
   e2 = vs[1]
  else
   e2 = vs[0]
  end
  
  # get adjacent edge
  p3 = e2.other_vertex(e1.end).position
  
  # center and normal
  v = p2-p1
  v.length = v.length/2
  mid1 = p1+v
  v = p3-p2
  v.length = v.length/2
  mid2 = p2+v
  
  # 3 planes
  plane1 = [mid1, e1.line[1]] 
  plane2 = [mid2, e2.line[1]]
  # gives the normal of the circle through the center
  cNormal =  Geom.intersect_plane_plane(plane1,plane2) 
  plane3 = [p1, e1.line[1].cross(e2.line[1])]
  c = Geom.intersect_line_plane(cNormal,plane3)
  
  if (circleInterior != nil)
   normalVec = circleInterior.normal
  else
   normalVec = cNormal[1]
  end
  
  segments = edgeArray.length/4
  pointsArray = Array.new()
  newEdges = Array.new()
  
  for i in 0..(segments) 
    pt = Geom::Point3d.new(p1.x ,p1.y ,p1.z)
    rot = Geom::Transformation.rotation(c, normalVec.cross(c-p1), i*(90.degrees/segments))
    pt.transform!(rot) 
    pointsArray.push(pt)
  end #for
  
  for i in 1..(pointsArray.length-1) 
    newEdges.push(ent.add_edges(pointsArray[i-1], pointsArray[i]).first)
  end #for
  
  oldPointsArray = pointsArray
  for k in 1..(edgeArray.length) 
   newPointsArray = Array.new()
   rot = Geom::Transformation.rotation(c, cNormal[1], k*(360.degrees/edgeArray.length))
   for i in 0..(pointsArray.length-1) 
    pt = Geom::Point3d.new(pointsArray[i].x ,pointsArray[i].y ,pointsArray[i].z)
    pt.transform!(rot) 
    newPointsArray.push(pt)
   end #for
   for i in 0..(newPointsArray.length-2) 
    newEdges.push(ent.add_edges(newPointsArray[i], newPointsArray[i+1]).first)
    newEdges.push(ent.add_edges(oldPointsArray[i], newPointsArray[i]).first)
   end #for
   for i in 0..(newPointsArray.length-3) 
    ent.add_face(oldPointsArray[i+1], oldPointsArray[i], newPointsArray[i], newPointsArray[i+1])
   end
  ent.add_face(oldPointsArray[oldPointsArray.length-2], newPointsArray[newPointsArray.length-2], newPointsArray[newPointsArray.length-1])
  oldPointsArray = newPointsArray
  end #for
  
  if (@smoothFaces) 
   newEdges.each { |e|
    e.smooth=true
    e.soft=true
   }
  end #if
  mod.commit_operation
end#if
