## Prism
require 'sketchup.rb'
def prism(n=4, l=1.0)
  # number of sides
  n = n.to_i
  n = 3 if n < 3
  # length of a side
  a = l.to_f
  a = 1.0 if a <= 0.0
  pi = Math::PI
  h = a
  r = a / (2 * Math.sin(pi / n)) # radius of enclosing circle
  mod = Sketchup.active_model # Open model
  mod.start_operation("Prism")
  ents=mod.active_entities
  group=ents.add_group()
  gents=group.entities
  bedges=gents.add_ngon(ORIGIN, Z_AXIS, r, n)
  tedges=gents.add_ngon(ORIGIN+[0,0,h], Z_AXIS, r, n)
  bface=gents.add_face(bedges)
  tface=gents.add_face(tedges)
  bedges[0].explode_curve
  tedges[0].explode_curve
  0.upto(n-1){|i|
    gents.add_face(bedges[i].start.position, bedges[i].end.position, tedges[i].end.position, tedges[i].start.position)
  }
  group.name="Prism["+n.to_s+"x"+l.to_s+"]"
  mod.commit_operation
end#def
=begin
Usage:
  Tool to make a 'Prism'.
  Type into Ruby Console:
    prism number_of_sides, length_of_a_side
  e.g. prism(3, 1.m)
  It is grouped and made centered at the origin.
  It is named 'Prism[3x1.000]'.
  Its height equals its side length.
=end
prism(3, 10.mm)
