## Cube
mod = Sketchup.active_model # Open model
ent = mod.entities # All entities in model
ent.clear!
# Define constant sqrt(3)
SQRT3 = Math.sqrt(3.0)
SQRT2 = Math.sqrt(2.0)
radius = 1.mm
# Draw base, reverse it to have it facing outwards, and pushpull it to height
base_down_by = -radius/SQRT3
square = ent.add_ngon [0,0, base_down_by], Z_AXIS, (radius/SQRT3)*SQRT2, 4
# Reverse to get front face outside
square.reverse!
# Add base to ent and pushpull it up to form the cube
base = ent.add_face square
base.pushpull 2.0*radius/SQRT3  
