## Octahedron
# Open model
mod = Sketchup.active_model 
# All entities in model
ent = mod.entities 
ent.clear!
# Octahedron has square centre of the same half-diagonal as the radius of its circumsphere
radius = 1.mm
# Draw base and define apex points
square = ent.add_ngon ORIGIN, Z_AXIS, radius , 4
top_apex = [0,0,radius]
bottom_apex = [0,0,-radius]
# Create the faces
edge1 = nil
edge2 = nil
for i in 0..3
  edge = square[i] 
  ent.add_face edge.start.position, edge.end.position, top_apex # top half  
  ent.add_face edge.start.position, edge.end.position, bottom_apex # bottom_half
  ent.each { |entity|
    entity.reverse! if entity.is_a? Sketchup::Face
  }
end #for
