## Tetrahedron
# Open model
mod = Sketchup.active_model 
# All entities in model
ent = mod.entities 
ent.clear!
# Define constant asin(0.333333) 
#  - angle between radius of solid and radius of base
ASIN_0333 = Math.asin(0.333333333333) # (in radians) = 19.471220614233577 degrees
# Define constant cos((asin(0.333333)) - angle between radius of base and edge of base
COS_ASIN_0333 = Math.cos(ASIN_0333)
radius= 1.mm
ent.add_cpoint(ORIGIN)
# Draw base and define apex point
base_down_by = -radius/3.0
triangle = ent.add_ngon [0,0, base_down_by], Z_AXIS, radius * COS_ASIN_0333, 3
# Reverse to get front face outside
triangle.reverse!
base = ent.add_face triangle
base_edges = base.edges
# Create the sides
apex = [0,0,radius]
for i in 0..2
  edge = base_edges[i] 
  tetrahedron = ent.add_face edge.start.position, edge.end.position, apex
  #Reverse faces round apex
  ent.each { |entity|
    entity.reverse! if entity.is_a? Sketchup::Face
  } 
end #for
