## Elliptic_Torus
# Open model
mod = Sketchup.active_model 
# All entities in model
ent = mod.entities 
ent.clear!
prompt = ["# Iterations : ", "c Value : "]
params = [5, 1.2]
result = inputbox(prompt, params, "Imput Elliptic Torus Parameters")
if result
  it = [2, result[0]].max
  c = result[1].abs
else
  return
end
group = ent.add_group
group_ents = group.entities
mesh_et = Geom::PolygonMesh.new
indexes = [0]
aux_vect = []
for ind_u in (-it..it-1)
  u = Math::PI*ind_u/it
  for ind_v in (-it..it-1)
    v = Math::PI*ind_v/it
    x = (c + Math::cos(v))*Math::cos(u)
    y = (c + Math::cos(v))*Math::sin(u)
    z = Math::sin(v) + Math::cos(v)
    pt = Geom::Point3d.new(100*x, 100*y, 100*z)
    index = mesh_et.add_point(pt)
    indexes.push(index)
  end #for
end #for
for ind_u in (1..2*it-1)
  for ind_v in (1..2*it-1)
    aux_ind = 2*it*(ind_u-1) + ind_v
    aux_vect = [indexes[aux_ind], indexes[aux_ind+2*it], indexes[aux_ind+1]]
    mesh_et.add_polygon(aux_vect)
    aux_vect = [indexes[aux_ind+1], indexes[aux_ind+2*it], indexes[aux_ind+1+2*it]]
    mesh_et.add_polygon(aux_vect)
  end #for
  aux_vect = [indexes[aux_ind+1], indexes[aux_ind+1+2*it], indexes[aux_ind+2-2*it]]
  mesh_et.add_polygon(aux_vect)
  aux_vect = [indexes[aux_ind+2-2*it], indexes[aux_ind+1+2*it], indexes[aux_ind+2]]
  mesh_et.add_polygon(aux_vect)
end #for
for ind_v in (1..2*it-1)
  aux_vect = [indexes[ind_v], indexes[ind_v+1], indexes[2*it*(2*it-1)+ind_v+1]]
  mesh_et.add_polygon(aux_vect)
  aux_vect = [indexes[ind_v], indexes[2*it*(2*it-1)+ind_v+1], indexes[2*it*(2*it-1)+ind_v]]
  mesh_et.add_polygon(aux_vect)
end #for
aux_vect = [indexes[2*it*(2*it-1)+1], indexes[4*it*it], indexes[2*it]]
mesh_et.add_polygon(aux_vect)
aux_vect = [indexes[1], indexes[2*it*(2*it-1)+1], indexes[2*it]]
mesh_et.add_polygon(aux_vect)
group_ents.add_faces_from_mesh(mesh_et)
Sketchup.send_action"viewZoomExtents:"
