## Horn Shape
# Open model
mod = Sketchup.active_model 
# All entities in model
ent = mod.entities 
ent.clear!
prompt = ["# Iterations : "]
params = [5]
result = inputbox(prompt, params, "Imput Horn Shape Parameters")
if result
  it = [2, result[0]].max
else
  return
end
group = ent.add_group
group_ents = group.entities
mesh_hs = Geom::PolygonMesh.new
indexes = [0]
aux_vect = []
for ind_u in (0..2*it)
  u = ind_u/(2.0*it)
  for ind_v in (0..2*it-1)
    v = 2*Math::PI*ind_v/(2*it)
    x = (2 + u*Math::cos(v))*Math::sin(2*Math::PI*u)
    y = (2 + u*Math::cos(v))*Math::cos(2*Math::PI*u) + 2*u
    z = u*Math::sin(v)
    pt = Geom::Point3d.new(100*x, 100*y, 100*z)
    index = mesh_hs.add_point(pt)
    indexes.push(index)
  end #for
end #for
for ind_u in (1..2*it)
  for ind_v in (1..2*it-1)
    aux_ind = 2*it*(ind_u-1) + ind_v
    aux_vect = [indexes[aux_ind], indexes[aux_ind+1], indexes[aux_ind+2*it]]
    mesh_hs.add_polygon(aux_vect)
    aux_vect = [indexes[aux_ind+1], indexes[aux_ind+1+2*it], indexes[aux_ind+2*it]]
    mesh_hs.add_polygon(aux_vect)
  end #for
  aux_vect = [indexes[aux_ind+1], indexes[aux_ind+2-2*it], indexes[aux_ind+1+2*it]]
  mesh_hs.add_polygon(aux_vect)
  aux_vect = [indexes[aux_ind+2-2*it], indexes[aux_ind+2], indexes[aux_ind+1+2*it]]
  mesh_hs.add_polygon(aux_vect)
end #for
group_ents.add_faces_from_mesh(mesh_hs)

