## Pisot_Triaxial
# Open model
mod = Sketchup.active_model 
# All entities in model
ent = mod.entities 
ent.clear!
prompt = ["# Iterations : "]
params = [5]
result = inputbox(prompt, params, "Imput Pisot Triaxial Parameters")
if result
  it = [2, result[0]].max
else
  return
end #if
group = ent.add_group
group_ents = group.entities
mesh_pt = Geom::PolygonMesh.new
indexes = [0]
aux_vect = []
for ind_u in (0..2*it-1)
  u = 2*Math::PI*ind_u/(2*it)
  for ind_v in (0..2*it-1)
    v = 2*Math::PI*ind_v/(2*it)
    x = 0.655866*Math::cos(1.03002+u)*(2 + Math::cos(v))
    y = 0.754878*Math::cos(1.40772-u)*(2 + 0.868837*Math::cos(2.43773+v))
    z = 0.868837*Math::cos(2.43773+u)*(2 + 0.495098*Math::cos(0.377696-v))
    pt = Geom::Point3d.new(100*x, 100*y, 100*z)
    index = mesh_pt.add_point(pt)
    indexes.push(index)
  end #for
end #for
for ind_u in (1..2*it-1)
  for ind_v in (1..2*it-1)
    aux_ind = 2*it*(ind_u-1) + ind_v
    aux_vect = [indexes[aux_ind], indexes[aux_ind+1], indexes[aux_ind+2*it]]
    mesh_pt.add_polygon(aux_vect)
    aux_vect = [indexes[aux_ind+1], indexes[aux_ind+1+2*it], indexes[aux_ind+2*it]]
    mesh_pt.add_polygon(aux_vect)
  end #for
  aux_vect = [indexes[aux_ind+1], indexes[aux_ind+2-2*it], indexes[aux_ind+1+2*it]]
  mesh_pt.add_polygon(aux_vect)
  aux_vect = [indexes[aux_ind+2-2*it], indexes[aux_ind+2], indexes[aux_ind+1+2*it]]
  mesh_pt.add_polygon(aux_vect)
end #for
for ind_v in (1..2*it-1)
  aux_vect = [indexes[ind_v], indexes[2*it*(2*it-1)+ind_v+1], indexes[ind_v+1]]
  mesh_pt.add_polygon(aux_vect)
  aux_vect = [indexes[ind_v], indexes[2*it*(2*it-1)+ind_v], indexes[2*it*(2*it-1)+ind_v+1]]
  mesh_pt.add_polygon(aux_vect)
end #for
aux_vect = [indexes[2*it*(2*it-1)+1], indexes[2*it], indexes[4*it*it]]
mesh_pt.add_polygon(aux_vect)
aux_vect = [indexes[1], indexes[2*it], indexes[2*it*(2*it-1)+1]]
mesh_pt.add_polygon(aux_vect)
group_ents.add_faces_from_mesh(mesh_pt)
Sketchup.send_action"viewZoomExtents:"
