## Egg
# *** Use a scaling transformation to turn ***
# *** a sphere into an ovoid
# Open the required collections
ent = Sketchup.active_model.entities
mod = Sketchup.active_model
sel = mod.selection
#  Clear the drawing pane
ent.clear!  
# Set up a properly scaled view for this example
view = Sketchup.active_model.active_view
eye = [16, 16,40]  # look from here
target = [0, 0, -2]  # to this point
up = [0, 0, 1]  # top of camera parallel to x-y plane
cam = Sketchup::Camera.new eye, target, up
view.camera = cam
# Get the current number of entities =
# the index of the next new entity
nent = ent.length  
# Create an extrusion circle
center = ORIGIN
radius = 10
circle = ent.add_circle center, Z_AXIS, radius
circle_face = ent.add_face circle
# Create the extrusion path
path = ent.add_circle center, Y_AXIS, radius + 1
# Create a sphere
circle_face.followme(path)
# Erase the path
ent.erase_entities path
# First entity should be an Edge
# No other edges should touch this construct
edge1 = ent[nent]
# Every edge connected to this edge is selected
egg = edge1.all_connected 
# Define an ovoidal transformation
t = Geom::Transformation.scaling 1.0,0.5,0.5
# Apply the ovoidal transformation
ent.transform_entities t, egg  
#  Maximize the view
Sketchup.send_action "viewZoomExtents:"  
sel.add egg
UI.messagebox "Selected"
sel.clear
UI.messagebox "Unselected"
