## Antiprism
require 'sketchup.rb'
def antiprism(n=4, l=1.0)
  ### number of sides
  n = n.to_i
  n = 3 if n < 3
  ### length of a side
  a = l.to_f
  a = 1.0 if a <= 0.0
  pi = Math::PI
  s = (Math.tan(pi / (2 * n))) * a / 2 # sagitta
  p = a * Math.sin(pi / 3) # hypotenhuse
  h = Math.sqrt(p**2 - s**2) # height between faces
  r = a / (2 * Math.sin(pi / n)) # radius of enclosing circle
  mod=Sketchup.active_model
  mod.start_operation("Antiprism")
  ent=mod.active_entities
  group=ent.add_group()
  gents=group.entities
  bedges=gents.add_ngon(ORIGIN, Z_AXIS, r, n)
  tedges=gents.add_ngon(ORIGIN+[0,0,h], Z_AXIS, r, n)
  tr=Geom::Transformation.rotation(ORIGIN, Z_AXIS, (2 * pi / n)/2)
  gents.transform_entities(tr, tedges)
  bface=gents.add_face(bedges)
  tface=gents.add_face(tedges)
  bedges[0].explode_curve
  tedges[0].explode_curve
  ###
  0.upto(n-1){|i|
    gents.add_face(bedges[i].start.position, bedges[i].end.position, tedges[i].start.position)
    gents.add_face(tedges[i].start.position, tedges[i].end.position, bedges[i].end.position)
  }
  group.name="Antiprism["+n.to_s+"x"+l.to_s+"]"
  mod.commit_operation
end#def
=begin
Usage:
  Tool to make an 'Antiprism'.
  Type into Ruby Console:
    antiprism number_of_sides, length_of_a_side
  e.g. antiprism(3, 1.m)
  It is grouped and made centered at the origin.
  It is named 'Antiprism[3x1.000]'.
=end
antiprism(3, 10.mm)
Sketchup.send_action "viewZoomExtents:"
