## WoodWorker
mod = Sketchup.active_model
ent = mod.entities
ent.clear!
Sketchup.send_action "viewFront:"  
side_wall = [ [0, 0, 6], [0, 0, 0], [-5, 0, 0],  [-5, 0, 6]]
ent.add_face side_wall # sides
frnt = [[-18, 0, 6], [-15, 0, 9], [-12, 0, 6], 
[-12, 0, 0], [-18, 0, 0]]
ent.add_face frnt  # front
bot = [[-11, 0, 5], [-6, 0, 5], [-6, 0, 0], [-11, 0, 0]]
ent.add_face bot  # bottom
rtrf = [[-19.3192, 0, -0.38487], [-22.6652, 0, 2.96116], 
[-22.6652, 0, 3.7035], [-19, 0, 0]]
ent.add_face rtrf  # right roof shape
lftr = [[-27.3648, 0, -0.0313162], [-23.6652, 0, 3.7035], 
[-23.6652, 0, 2.96116], [-27.0112, 0, -0.38487]]
ent.add_face lftr  #  left roof shape
# UI.messagebox "Next Step?" 
ent.clear! # clear the drawing pane
bottom = ent.add_face bot #  make the bottom shape
pbo = [5.5, -0.500, 0.000] # => [-0.5, -0.5, 0] - [-6, 0, 0] 
# Rotate it in place 90 degrees about the X-axis  
tbo2 = Geom::Transformation.rotation [-6, 0, 0], [1,0,0], 1.5708
ent.transform_entities tbo2, bottom
# Move the required relative distance to the new location
tbo1 = Geom::Transformation.new pbo
ent.transform_entities tbo1, bottom 
bottom.pushpull 0.5  #  Make the bottom
# UI.messagebox "Next Step?" 
# Make the side1 shape
side1 = ent.add_face side_wall
# Rotate it in place 90 degrees about the Z-axis  
tsi2 = Geom::Transformation.rotation [0, 0, 0], [0,0,1], 1.5708
ent.transform_entities tsi2, side1
# Move the required relative distance to the new location
tsi1 = Geom::Transformation.new [-0.5,-0.5,0] # => [-0.5,-0.5,0] - [0,0,0]
ent.transform_entities tsi1, side1 
side1.pushpull -0.5  # Make side1
# UI.messagebox "Next Step?" 
# Make the side2 shape
side2 = ent.add_face side_wall
# Rotate it in place 90 degrees about the Z-axis  
tsi2 = Geom::Transformation.rotation [0, 0, 0], [0,0,1], 1.5708
ent.transform_entities tsi2,side2
# Move the required relative distance to the new location
tsi1 = Geom::Transformation.new [-5.5,-0.5,0] # = > [-0.5,-0.5,0] - [0,0,0]
ent.transform_entities tsi1,side2 
side2.pushpull  0.5   # Make the side2 wall
# UI.messagebox "Next Step?" 
Sketchup.send_action "viewBack:" 
Sketchup.send_action "viewIso:" 
# Make the front shape
front = ent.add_face frnt
# Define the required relative distance to the new location
tfro = Geom::Transformation.new [12.0,-0.5,0]  # = > [0,-0.5,0] - [-12,0,0]
# UI.messagebox "Next Step?" 
# Make a punch-out for the entry 
edges = ent.add_circle [-15,0.01,6], [0,1,0], 1
hole = ent.add_face edges  #
# front = ents.add_face frnt
# Move the punch-out circle into position
ent.transform_entities tfro, hole 
# UI.messagebox "Next Step?" 
# Then the front shape
ent.transform_entities tfro, front
# UI.messagebox "Next Step?" 
# Make a hole in the front shape 
hole.pushpull    -0.01
status = hole.erase!
# Make the front wall
front.pushpull 0.5
# UI.messagebox "Next Step?" 
# Make the back shape
back = ent.add_face frnt
# Move it the required relative distance to the new location
tfro = Geom::Transformation.new [12.0,-5.5,0]  # = > [0,-5.5,0] -[-12,0,0] 
ent.transform_entities tfro, back 
back.pushpull  -0.5 # Make the back wall
# UI.messagebox "Next Step?" 
# Make the right roof shape
right_roof  = ent.add_face rtrf
# Move it the required relative distance to the new location
t = Geom::Transformation.new [19.67,-7.0,6.04]  # = > [-3,-7,9] -[-22.67,0,2.96] 
ent.transform_entities t,right_roof  
right_roof.pushpull 8 # Make the right roof
# UI.messagebox "Next Step?"  
# Make the left roof shape
left_roof  = ent.add_face lftr
# Move it the required relative distance to the new location
t= Geom::Transformation.new [20.67,-7,6.04]  # = > [-3,-7,9] -[-23.67,0,2.96]
ent.transform_entities t, left_roof  
left_roof.pushpull 8 # Make the left roof
# UI.messagebox "Next Step?" 
# Move the camera into proper view
Sketchup.send_action "viewBack:" 
Sketchup.send_action "viewIso:"
Sketchup.send_action "viewZoomExtents:"
