## bar_pull
# Access the Entities object
mod = Sketchup.active_model
ent = mod.entities
ent.clear!
#--[
def bar_pull(ctoc, rad,len, hp, ent)
# Place construction points at A = [3.0,0.0,0.0] and B = [-1.195,0.0,1.135].
# Put circles of radius 0.235 at the origin and at point A in the x-y plane.
# Put a circle of radius 0.235 at point B in the x-z plane.
# Pushpull the first two circles to a height of 1.135.
# Pushpull the third circle to a length of 5.39.    
norm   = [0, 0, 1]
begin # use informative error handling
# Draw and pushpull each of the circles
edges=ent.add_circle(ctoc[0], norm, rad)
face = ent.add_face(edges)
face.pushpull -hp
edges=ent.add_circle(ctoc[1], norm, rad)
face = ent.add_face(edges)
face.pushpull -hp
norm   = [1, 0, 0]
edges=ent.add_circle(ctoc[2], norm, rad)
face = ent.add_face(edges)
face.pushpull len
rescue # Post error messages and continue
puts "Erroneous input: "
puts "ctoc,rad,len,hp = "+[ctoc, rad,len, hp].inspect
puts "Backtrace:\n\t#{exception.backtrace.join("\n\t")}"
end
end #def
#--]
centers = [] # pushpull circle centers
rad = 0.235 # = post radius
len = 5.39 # = bar length
hp = 1.135 # = post height
centers = [[0,0,0],[3,0,0],[-1.195,0.0,1.135]]
ent # Add as argument to better track entity formation
bar_pull(centers, rad, len, hp, ent)
Sketchup.send_action"viewZoomExtents:"
