# cotter_pin
# Make a cotter pin model
# Get the necessary collections
mod = Sketchup.active_model
ent = mod.active_entities
mats = mod.materials
sel = mod.selection
bbox = mod.bounds
ent.clear!
#--[
def stitch p1, p2, ent
# Stitch two faces into a volume.  This version is specialized for curves. 
# p1 and p2 must have the same number of points
# Connecting points must be adjacent
n = p1.length
#Make the faces
#Circle curves have equal beginning and end points.
for k in 0..n-2
  ent.add_face p1[k],p2[k+1],p2[k]
  ent.add_face p1[k],p1[k+1],p2[k+1]
end #for
end #def
#--]

# Cross-section of circle - in general, an arbitrary shape
pts0 = [[-0.044,-0.625,0.013],[-0.044,-0.627,0.0],[-0.044,-0.625,-0.013],[-0.044,-0.620,-0.025],[-0.044,-0.612,-0.035],[-0.044,-0.602,-0.043],[-0.044,-0.590,-0.048],[-0.044,-0.577,-0.050],[-0.044,-0.564,-0.048],[-0.044,-0.552,-0.043],[-0.044,-0.542,-0.035],[-0.044,-0.534,-0.025],[-0.044,-0.529,-0.013],[-0.044,-0.527,0.0],[-0.044,-0.529,0.013],[-0.044,-0.534,0.025],[-0.044,-0.542,0.035],[-0.044,-0.552,0.043],[-0.044,-0.564,0.048],[-0.044,-0.577,0.050],[-0.044,-0.590,0.048],[-0.044,-0.602,0.043],[-0.044,-0.612,0.035],[-0.044,-0.620,0.025]]

#Shape definition path
pth = [[0.0,0.0,0.0],[0.383,-0.131,0.0],[0.765,-0.263,0.0],[0.857,-0.275,0.0],[0.895,-0.270,0.0],[0.954,-0.259,0.0],[0.994,-0.240,0.0],[1.211,-0.059,0.0],[1.390,0.073,0.0],[1.450,0.092,0.0],[1.521,0.096,0.0],[1.629,0.090,0.0],[1.933,0.028,0.0],[2.035,0.007,0.0],[2.115,0.007,0.0],[2.168,0.021,0.0],[2.244,0.042,0.0],[2.618,0.405,0.0],[3.015,0.795,0.0],[3.092,0.850,0.0],[3.185,0.890,0.0],[3.270,0.906,0.0],[3.370,0.910,0.0],[3.473,0.888,0.0],[3.591,0.838,0.0],[3.683,0.775,0.0],[3.748,0.708,0.0],[3.816,0.620,0.0],[3.857,0.499,0.0],[3.873,0.329,0.0],[3.858,0.225,0.0],[3.830,0.116,0.0],[3.742,0.001,0.0],[3.624,-0.098,0.0],[3.486,-0.157,0.0],[3.409,-0.177,0.0],[0.264,-0.531,0.0],[-0.044,-0.577,0.0]]

 n = pth.length-1
 seg = []
 norm = pth[1].vector_to pth[0]
# Make circles perpendicular to the path segment 
# Additional coding required here if the cross-section is an arbitrary shape:
# e.g. find the plane of the cross-section and define a transformation
 circle0 = ent.add_circle pth[0],norm,0.05
# Get an edge of the circle
 edge = circle0[7]
# Get the curve connected to the edge
 curve = edge.curve
# Put the vertices of the curve into a points array
 seg[0] = curve.vertices
# Make an end face for the cotter pin
 face = ent.add_face seg[0]
# Repeat this process for the other path segments
 for k in 1..n
  norm = pth[k].vector_to pth[k-1]
  circlek = ent.add_circle pth[k],norm,0.05
  edge = circlek[7]
  curve = edge.curve
  seg[k] = curve.vertices
  stitch seg[k-1],seg[k],ent
 end #for
# Make the end faces for the cotter pin
face = ent.add_face seg[0]
face = ent.add_face seg[n]
Sketchup.send_action"viewIso:"
Sketchup.send_action"viewZoomExtents:"
