## House
class House
# Create instance variables and their accessor methods
attr_accessor :num_windows, :door_index  
# Allow objects to be created with initialized data
def initialize(num_windows, door_index)  
 @num_windows = num_windows  
 @door_index = door_index
end #def
# Draw the house
def draw
  # Set the house dimensions (in feet)
  door_width = 3      
  door_height = 7
  house_height = 9
  house_length = (@num_windows + 1) * (door_width + 2) + 2
  house_width = 10
  roof_height = 2
  # Create the main box
  mod = Sketchup.active_model
  mod.close_active
  ent = mod.entities
  ent.clear!
  ent.add_face([0, 0, 0], [0, house_length, 0],
     [house_width, house_length, 0], 
     [house_width, 0, 0], [0, 0, 0]).pushpull(-1 * house_height)
  for count in 0..@num_windows
     offset = 2 + count * (door_width + 2)
     if @door_index == count
        ent.add_curve([house_width, offset, 0],
           [house_width, offset, door_height], 
           [house_width, offset + door_width, door_height], 
           [house_width, offset + door_width, 0])[0].faces[1].pushpull(-1)
     else
        ent.add_face([house_width, offset, 4],
           [house_width, offset, door_height], 
           [house_width, offset + door_width, door_height], 
           [house_width, offset + door_width, 4], 
           [house_width, offset, 4]).pushpull(-1)
     end
  end
  # Create the roof_line
  roof_line = ent.add_line([0, house_length/2.0, house_height], 
     [house_width, house_length/2.0, house_height])
  tr = Geom::Transformation.translation [0, 0, 5]
  ent.transform_entities tr, roof_line
end #def
end #class
h = House.new 4,2
h.draw
Sketchup.send_action"viewZoomExtents:"

