## plyboat.rb
mod = Sketchup.active_model
ent = mod.active_entities
mats = mod.materials
sel = mod.selection
#Clear the drawing pane of last execution results
ent.clear!  
#[
def stitch p1, p2, ent
# This Variant does not add the final face
 n = p1.length
 for k in 0..n-2
   ent.add_face p1[k],p1[k+1],p2[k+1],p2[k]
 end #for
end #def
#]
#[
def plyboat(param,ent)
# Set the parameters from the param array
 a,b,c,d,e,f,g,h,r,s = param ; step = 0;
# Define the section shape
 shape = [[b/2,0,c],[a/2,0,0],[-a/2,0,0],[-b/2,0,c]]
# Make the rear midsection
 shape2 = ent.add_face shape
 t = Geom::Transformation.new [0,d,0]
 ent.transform_entities t, shape2
#	Make the aft section. 
 shape3 = ent.add_face shape
 t1 = Geom::Transformation.new [0,e,r] # Position it
 t2 = Geom::Transformation.scaling g   # Scale it
 ent.transform_entities t2, shape3
 ent.transform_entities t1, shape3
# Make the forward section. 
 shape4 = ent.add_face shape
 t3 = Geom::Transformation.new [0,f,s] # Position it
 t4 = Geom::Transformation.scaling h   # Scale it
 ent.transform_entities t4, shape4
 ent.transform_entities t3, shape4
 shape1 = ent.add_face shape
# Get the point array for the first and forward shapes
 pts1 = []
 pts2 = []
 pts1 = shape1.vertices
 pts2 = shape2.vertices
# Stitch the faces to 3D 
 stitch pts1, pts2, ent
 pts1 = shape1.vertices
 pts2 = shape4.vertices
# Selectively add a face
 ent.add_face pts1[0],pts1[3],pts2[3],pts2[0]
# Stitch the faces into 3D 
 stitch pts1, pts2, ent
 pts1 = shape2.vertices
 pts2 = shape3.vertices
# Stitch the faces into 3D 
 stitch pts1, pts2, ent
# Selectively add a face
 ent.add_face pts1[0],pts1[3],pts2[3],pts2[0]
# Erase undesired faces
 ent.erase_entities shape1
 ent.erase_entities shape2
 end #def
#]
# The interactive version used these parameters:
# a = 62.0, b = 84.0, c = 30.0, d = 60.0, e = 84.0, f = -48.0, g = 0.8, h = 0.5, s = 6.0
#param = [a,b,c,d,e,f,g,h,r,s]
param = [60.0,84.0,30.0,60.0, 84.0,-48.0,0.8,0.5,6,15]
plyboat(param,ent)
Sketchup.send_action"viewIso:"
Sketchup.send_action"viewZoomExtents:"
