# propeller
mod = Sketchup.active_model
ent = mod.active_entities
mats = mod.materials
sel = mod.selection
ent.clear!
def stitch p1, p2, ent
# This version requires faces made of four co-planar points
 n = p1.length
 for k in 0..n-2
# make faces to connect point array p1 to p2 
 ent.add_face p1[k],p1[k+1],p2[k+1],p2[k]
 end
 k=n-2
# Stitch first and last points
 ent.add_face p1[0],p1[k+1],p2[k+1],p2[0]
end #def
def prop_maker(len, root, tip, ent, sel)
# Airfoil definition = propeller cross section
 pts0 = [[8.454, -0.988,0], [8.025, -0.823, 0], 
 [0, 0, 0], [2.299, -0.592, 0], [3.380, -0.832, 0], 
 [4.720, -1.116, 0], [5.949, -1.316,0], 
 [7.121, -1.507, 0], [7.850, -1.498, 0], 
 [8.321, -1.360, 0], [8.487, -1.182, 0]]
 nb=ent.length  # the first available entities index
# Make an airfoil face for the tip
 prop = ent.add_face pts0
 n = pts0.length-1 # index of the last pts0 array value
# Define the scaling transformations
 t1 = Geom::Transformation.scaling root
 t2 = Geom::Transformation.scaling tip
# specify the tip location
 t3 = Geom::Transformation.new [0,0,len]
# Put a scaled version of the airfoil in the tip location
 ent.transform_entities t2, prop
 ent.transform_entities t3, prop
# Make an airfoil face for the root
 proot = ent.add_face pts0
# Scale the root face
 ent.transform_entities t1, proot
# Make the root array values
 pts1 = proot.vertices 
# Dummy transformation to obtain cowl Y location
 point2 = Geom::Point3d.new 0,0,0
 t = Geom::Transformation.new(point2)
 point1 = Geom::Point3d.new pts1[n].position
 b = point1.transform t
# Should be able to set by = [pts1[n].position].y
 by = b.y
# Make the tip array values 
 pts2 = prop.vertices
# Make the propeller blade
 stitch pts1, pts2, ent
# Clear the selection
 sel.clear
 ne=ent.length-1 # Total number of entitities created
# Select propeller entities
  for i in nb..ne
  sel.add(ent[i])
  end
# Define a rotation transformation
  vector = [0,1,0] # Rotate in the X-Z plane
  angle = 1.2566 # 72 degree angle
  t = Geom::Transformation.rotation [0,0,0], vector, angle
# Make the selection a group
  group  = ent.add_group sel
# Copy the group
  group1 = group.copy
# Rotate it 72 degrees
  ent.transform_entities t, group1
# Copy the previous group
  group2 = group1.copy
# Rotate it 72 degrees
  ent.transform_entities t, group2
  group3 = group2.copy
  ent.transform_entities t, group3
  group4 = group3.copy
  ent.transform_entities t, group4
# Define a cowling cross section
 pts = [[0, -0.546, 0], [0, -2.672, 0], [0, -3.879, 0], 
 [0, -3.879, 2.367], [0, -2.672, 5.434], 
 [0, -1.603, 9.137], [0, 0, 9.137], [0, 0, 0]]
# Make it a face
 cowl = ent.add_face pts
 status = cowl.reverse! # Turn extrusion faces outward 
 t5 = Geom::Transformation.new [0,by,0]
# Scale it to the root scaling
 ent.transform_entities t1, cowl
# Move it to its proper location
 ent.transform_entities t5, cowl
# Create an extrusion path
  path = ent.add_circle [0,0,0], [0, 1, 0], 7
# Create a cowl
  cowl.followme(path)
# Erase the path
  ent.erase_entities path
end #def
prop_maker 18,0.5, 0.4, ent, sel
Sketchup.send_action"viewIso:"
Sketchup.send_action"viewZoomExtents:"
  

